/*
 ķ
   Program..: _DCEXPL.PRG                           
   Author...: Roger J. Donnay                       
   Notice...: (c) DONNAY Software Designs 1987-2000 
   Date.....: Feb 18, 2000                          
   Notes....: Explode and Implode functions         
                                                    
   Functions: dc_explode(), dc_implode(), dc_expl() 
              dc_say(), dc_impl(), dc_altshadow()   
              dc_pushscrn(), dc_popscrn()           
              dc_waiton(), dc_maxrow(), dc_maxcol() 
              dc_cls()                              
 Ľ
*/

#include "dccolor.ch"
#include "appevent.ch"
#include "dcdialog.ch"
#include "dccursor.ch"
#INCLUDE "dcmsg.CH"

MEMVAR dCLIP, dCCOLOR

STATIC aExplode := { .f., 1 }, saScreen := nil, saWait


#define lINSTANTON       aExplode[1]
#define nSHADOW          aExplode[2]

FUNCTION dc_explode ( nSrow, nScol, nErow, nEcol, cColor1, cColor2, lTone,;
                     cTitle, nSlideRate, lShadow, lPaintOnly, lDouble,;
                     lPushScrn )

LOCAL   nSlide, nRow, nStep, nSaveCol, nSaveRow, cSaveScreen, nExplSrow, ;
        nExplScol, nExplErow, nExplEcol, cBuffer, cSaveColor, nCol, ;
        nStCol, nEnRow, nEnCol, lMouVisible, cColorString

cColorString := cC_EXPBOXC+','+cC_CURRGET+',,,'+cC_PENDGET
DC_CLRARR()  // Initialize color array
DC_VALTYPE( @nSrow,0,  @nScol,0,  @nErow, DC_MaxRow(),  @nEcol, DC_MaxCol(),;
            @lTone,.f.,  @nSlideRate,0,  @cTitle,'',  @lShadow,.t.,;
            @lPaintOnly,.f.,  @lDouble,.f.,  @lPushScrn,.f., ;
            @ cColor1, cC_EXPBOXF, @cColor2, cColorString )

nExplSrow := nSrow + ( nErow - nSrow ) / 2
nExplScol := nScol + ( nEcol - nScol ) / 2
nExplErow := nExplSrow
nExplEcol := nExplScol
cSaveColor := setcolor()

/*-------------------( Begin sliding box )---------------------*/

IF nSlideRate > 0 .AND. !lPaintOnly .AND. !lINSTANTON .AND. !lPushScrn
  nSaveRow := row()
  nSaveCol := col()
  nStep := iif( nSaveRow > nExplSrow, -1, 1 )
  DC_COLOR( cColor1 )
  FOR nRow := nSaveRow TO nExplSrow STEP nStep
    cSaveScreen := SaveScreen( nRow, nSaveCol, nRow + 1, nSaveCol + 3 )
    @ nRow, nSaveCol TO nRow + 1, nSaveCol + 3
    FOR nSlide := 0 TO nSlideRate
    NEXT
    RestScreen( nRow, nSaveCol, nRow + 1, nSaveCol + 3, cSaveScreen )
  NEXT
  nStep := iif( nSaveCol > nExplScol, -5, 5 )
  FOR nCol := nSaveCol TO nExplScol STEP nStep
    cSaveScreen := SaveScreen( nRow, nCol, nRow + 1, nCol + 3 )
    @ nRow, nCol TO nRow + 1, nCol + 3
    FOR nSlide := 1 TO nSlideRate * 2
    NEXT
    RestScreen( nRow, nCol, nRow + 1, nCol + 3, cSaveScreen )
  NEXT
ENDIF

/*-------------------( End sliding box )---------------------*/

nStCol := nScol
nEnCol := nEcol
nEnRow := nErow
IF nErow < DC_MaxRow()
  nEnRow := nErow + 1
ENDIF
IF nSHADOW = 2
  IF nEcol < DC_Maxcol() - 1
    nEnCol := nEcol + 2
  ENDIF
ELSE
  IF nScol > 1
    nStCol := nScol - 2
  ENDIF
ENDIF
cSaveScreen := Savescreen( nSrow, nStCol, nEnRow, nEnCol )

IF !lPushScrn
  IF lTone
    INKEY()
    TONE( 1000, 1 )
  ENDIF
  IF !lPaintOnly .AND. !lINSTANTON .AND. !lPushScrn
    DO WHILE nExplScol > nScol
      DC_COLOR( cColor1 )
      @ nExplSrow, nExplScol TO nExplErow, nExplEcol
      DC_COLOR( cColor2 )
      @ nExplSrow + 1, nExplScol + 1 CLEAR TO nExplErow - 1, nExplEcol - 1
      nExplScol -= 4
      nExplEcol += 4
      nExplSrow--
      nExplErow++
      IF nExplSrow < nSrow
        nExplSrow := nSrow
        nExplErow := nErow
      ENDIF
      IF nExplScol < nScol
        nExplScol := nScol
        nExplEcol := nEcol
      ENDIF
    ENDDO
  ENDIF
  IF lTone
    INKEY()
    TONE( 4000, 1 )
  ENDIF
  IF iscolor()
    DC_COLOR( cColor1 )
    IF lDouble
      @ nSrow, nScol TO nErow, nEcol DOUBLE
    ELSE
      @ nSrow, nScol TO nErow, nEcol
    ENDIF
  ELSE
    @ nSrow, nScol TO nErow, nEcol DOUBLE
  ENDIF
  DC_COLOR( cColor2 )
  @ nSrow + 1, nScol + 1 CLEAR TO nErow - 1, nEcol - 1
  IF !empty( cTitle )
    DC_COLOR( cColor1 )
    @ nSrow, nScol + ( nEcol - nScol ) / 2 - len( cTitle ) / 2 SAY Chr(180) + cTitle + Chr(195)
    DC_COLOR( cColor2 )
  ENDIF

  IF lShadow .AND. nSHADOW > 0
    DO CASE
      CASE nSHADOW = 2
        // Draw Right Side
        IF nEcol < DC_Maxcol()-1
          DC_PaintShadow( nSrow + 1, nEcol + 1, nErow, nEcol + 2 )
        ENDIF
      CASE nSHADOW = 1
        // Draw Left Side
        IF nScol > 1
          DC_PaintShadow( nSrow + 1, nScol - 2, nErow, nScol - 1 )
        ENDIF
    ENDCASE
    // Draw Bottom
    IF nErow < DC_MaxRow()
      DO CASE
        CASE nSHADOW = 2
          DC_PaintShadow( nErow + 1, nScol+2, nErow + 1, nEcol )
        CASE nSHADOW = 1
          DC_PaintShadow( nErow + 1, nScol, nErow + 1, nEcol - 2 )
      ENDCASE
    ENDIF
    DO CASE
      CASE nSHADOW = 2
        // Draw Lower Right Corner
        IF nErow < DC_MaxRow() .AND. nEcol < DC_Maxcol() - 1
          DC_PaintShadow( nErow + 1, nEcol +1, nErow + 1, nEcol + 2 )
        ENDIF
      CASE nSHADOW = 1
        // Draw Lower Left Corner
        IF nErow < DC_MaxRow() .AND. nScol > 1
          DC_PaintShadow( nErow + 1, nScol - 2, nErow + 1, nScol - 1 )
        ENDIF
    ENDCASE
  ENDIF
ENDIF
RETURN { nSrow, nStcol, nEnRow, nEncol, lTone, lPaintOnly, cColor1, ;
         cColor2, cSaveColor, cSaveScreen }

/*-------------------*/

FUNCTION dc_implode( cSaveScreen, lPopScrn )

LOCAL aImplode[15]
#define cEXPLSCRN   aImplode[1]
#define nEXPLSROW   aImplode[2]
#define nEXPLSCOL   aImplode[3]
#define nEXPLEROW   aImplode[4]
#define nEXPLECOL   aImplode[5]
#define lTONE       aImplode[6]
#define nDELAY      aImplode[7]
#define nSROW       aImplode[8]
#define nSCOL       aImplode[9]
#define nEROW       aImplode[10]
#define nECOL       aImplode[11]
#define cCOLOR1     aImplode[12]
#define cSAVECOLOR  aImplode[13]
#define lPAINTONLY  aImplode[14]

CLEAR TYPEAHEAD

lPopScrn := IIF(Valtype(lPopScrn)='L',lPopScrn,.f.)
IF Valtype(cSaveScreen)='C'
  nSROW := val( substr( cSaveScreen, 1, 3) )
  nSCOL := val( substr( cSaveScreen, 4, 3) )
  nEROW := val( substr( cSaveScreen, 7, 3) )
  nECOL := val( substr( cSaveScreen,10, 3) )
  lTONE := iif( substr( cSaveScreen,13, 1 ) == 'Y', .t., .f. )
  lPAINTONLY := iif( substr( cSaveScreen, 14, 1 ) == 'Y', .t., .f. )
  cCOLOR1 := alltrim( substr( cSaveScreen, 15, 20 ) )
  cSAVECOLOR := alltrim( substr( cSaveScreen, 55, 25 ) )
  cSaveScreen := substr( cSaveScreen, 80 )
ELSEIF Valtype(cSaveScreen)='A'
  nSROW := cSaveScreen[1]
  nSCOL := cSaveScreen[2]
  nEROW := cSaveScreen[3]
  nECOL := cSaveScreen[4]
  lTONE := cSaveScreen[5]
  lPAINTONLY := cSaveScreen[6]
  cCOLOR1 := cSaveScreen[7]
  cSAVECOLOR := cSaveScreen[9]
  cSaveScreen := cSaveScreen[10]
ELSE
  RETURN .f.
ENDIF
IF lTONE
  INKEY()
  TONE( 4000, 1 )
ENDIF
IF !lPAINTONLY .AND. !lINSTANTON .AND. !lPopScrn
  IF nEROW < DC_MaxRow() .AND. IIF(nSHADOW=2, nECOL<DC_Maxcol()-1,nSCOL > 1)
    cEXPLSCRN := SaveScreen( nSROW, nSCOL, nEROW, nECOL )
    RestScreen( nSROW, nSCOL, nEROW, nECOL, cSaveScreen )
    cSaveScreen := SaveScreen( nSROW, nSCOL, nEROW, nECOL )
    RestScreen( nSROW, nSCOL, nEROW, nECOL, cEXPLSCRN )
  ENDIF
  nEXPLSROW := nSROW
  nEXPLSCOL := nSCOL
  nEXPLEROW := nEROW
  nEXPLECOL := nECOL
  DO WHILE nEXPLSCOL < nEXPLECOL
    nEXPLSCOL += 4
    nEXPLECOL -= 4
    nEXPLSROW++
    nEXPLEROW--
    IF nEXPLSROW >= nEXPLEROW
      nEXPLSROW--
      nEXPLEROW++
    ENDIF
    cEXPLSCRN := SaveScreen( nEXPLSROW, nEXPLSCOL, nEXPLEROW, nEXPLECOL )
    RestScreen( nSROW, nSCOL, nEROW, nECOL, cSaveScreen )
    RestScreen( nEXPLSROW, nEXPLSCOL, nEXPLEROW, nEXPLECOL, cEXPLSCRN )
    DC_COLOR( cCOLOR1 )
    @ nEXPLSROW, nEXPLSCOL TO nEXPLEROW, nEXPLECOL
    FOR nDELAY := 1 TO 10
    NEXT
  ENDDO
ENDIF
RESTSCREEN( nSROW, nSCOL, nEROW, nECOL, cSaveScreen )
DC_COLOR( TRIM(cSAVECOLOR) )
IF lTONE
  INKEY()
  TONE( 1000, 1 )
ENDIF
RETURN .t.

*----------------

FUNCTION dc_expl( nStartRow, nStartCol, nEndRow, nEndCol,;
                  cTitle, lNoShadow, lPaintOnly, lCenter, ;
                  lRelative, cFont, lGui )

LOCAL oParent, nWidth, nHeight, nCol, nRow, oDlg, drawingArea

cTitle := IIF(Valtype(cTitle)='C',cTitle,'')
lNoShadow := IIF(Valtype(lNoShadow)='L',lNoShadow,.f.)
lPaintOnly := IIF(Valtype(lPaintOnly)='L',lPaintOnly,.f.)
lCenter    := IIF(Valtype(lCenter)='L',lCenter,.f.)
lRelative  := IIF(Valtype(lRelative)='L',lRelative,.t.)
cFont      := IIF(Valtype(cFont)='C',cFont,'10.Courier')
lGui       := IIF(Valtype(lGui)='L',lGui,DC_Gui())

IF lGui
  oParent := SetAppWindow():setParent()
  IF Valtype(oParent) # 'O'
    oParent := AppDeskTop()
  ENDIF
  nWidth := (nEndCol-nStartCol+1)*8
  nHeight := (nEndRow-nStartRow+1)*18
  IF lCenter
    nCol := (oParent:currentSize()[1]-nWidth)/2
    nRow := (oParent:currentSize()[2]-nHeight)/2
  ELSE
    nCol := nStartCol*8
    nRow := oParent:currentSize()[2]-nHeight-(nStartRow*18)
  ENDIF
  oDlg := XbpDialog():new( oParent,,{nCol,nRow},{nWidth,nHeight},,.f.)
  oDlg:visible := .F.
  oDlg:title := cTitle
  IF Valtype(DC_IconDefault())='N'
    oDlg:icon := DC_IconDefault()
  ENDIF
  oDlg:create()
  DC_CenterObject(oDlg,SetAppWindow())
  oDlg:cargo := {}
  drawingArea := oDlg:drawingArea
  drawingArea:setColorBG( XBPSYSCLR_DIALOGBACKGROUND )
  drawingArea:setFontCompoundName( cFont )
  oDlg:show()
  saScreen := { nStartRow, nStartCol, nEndRow, nEndCol, nil, ;
                nil, nil, nil, nil, oDlg, lRelative, cFont, lGui, nil }
  RETURN saScreen

ENDIF
saScreen := DC_EXPLODE( nStartRow, nStartCol, nEndRow, nEndCol,,, .f., ;
                        cTitle, 4, !lNoShadow, lPaintOnly )
AADD( saScreen, lRelative )
AADD( saScreen, cFont )
AADD( saScreen, lGui )
AADD( saScreen, nil )

RETURN saScreen

/*-------------------*/

FUNCTION dc_impl( acSaveScreen )

LOCAL cImplode, lEmptyScreen := .f.

IF Empty(acSaveScreen)
  acSaveScreen := saScreen
  lEmptyScreen := .t.
ENDIF
IF Valtype(acSaveScreen)='A' .AND. Valtype(acSaveScreen[10])='O'
  ASize(acSaveScreen,15)
  IF Valtype(acSaveScreen[10]:cargo) = 'A' .AND. Len(acSaveScreen[10]:cargo) >= 2
    acSaveScreen[10]:cargo[2] := .f.
    DO WHILE Valtype(acSaveScreen[14]) = 'O' .AND. acSaveScreen[14]:active
      Sleep(5)
    ENDDO
  ENDIF
  IF acSaveScreen[10]:status() == 1
    DEFAULT acSaveScreen[15] := .f.
    IF acSaveScreen[15] // modal
      acSaveScreen[10]:setModalState(XBP_DISP_MODELESS)
    ENDIF
    acSaveScreen[10]:Destroy()
  ENDIF
  IF lEmptyScreen
    saScreen := nil
  ELSE
    acSaveScreen := nil
  ENDIF
  saWait := nil
  Sleep(5)
  RETURN .t.
ENDIF
DC_ClrArr()
DC_Implode( acSaveScreen )
saWait := nil
saScreen := nil
acSaveScreen := nil
RETURN .t.

*-------------------

FUNCTION dc_say ( acSaveScreen, nRow, nCol, cText, lOk, cFont, cColor )

LOCAL  nStartRow := 0, nStartCol := 0, oXbp, nHeight, nEvent, ;
       mp1, mp2, lEmptyScreen := .f., lRelative, nParentSrow, ;
       nParentScol, nParentErow, nParentEcol, cParentFont, ;
       oDialog, aPres, aColor, aChildren, i

IF Empty(acSaveScreen)
  acSaveScreen := saScreen
  lEmptyScreen := .t.
ENDIF

nRow   := IIF(Valtype(nRow)='N',nRow,0)
nCol   := IIF(Valtype(nCol)='N',nCol,0)
cText  := IIF(Valtype(cText)='C',cText,'')
lOk    := IIF(Valtype(lOk)='L',lOk,.f.)
IF Valtype(acSaveScreen) = 'A' .AND. Valtype(acSaveScreen[10])='O'
  oDialog     := acSaveScreen[10]
  nParentSrow := acSaveScreen[1]
  nParentScol := acSaveScreen[2]
  nParentErow := acSaveScreen[3]
  nParentEcol := acSaveScreen[4]
  lRelative   := acSaveScreen[11]
  lRelative := IIF( Valtype(lRelative)='L',lRelative,.t.)
  cParentFont := acSaveScreen[12]
  SetAppFocus(oDialog)
  IF !lRelative
    nRow -= nParentSrow
    nCol -= nParentScol
  ENDIF
  nHeight := oDialog:currentSize()[2]
  nRow := nRow * 18
  nRow := nHeight - nRow - 30
  nCol := nCol * 7
  IF lOk
    oXbp := XbpPushButton():new( oDialog:drawingArea, , { nCol, nRow }, {50,22} )
    oXbp:caption := cText
    oXbp:clipSiblings := .T.
    oXbp:create()
    oXbp:activate := {||PostAppEvent(xbeP_Close)}
    SetAppFocus(oXbp)
    nEvent := xbeP_None
    CLEAR TYPEAHEAD
    DO WHILE nEvent <> xbeP_Close
      oXbp := nil
      nEvent := AppEvent( @mp1, @mp2, @oXbp, 1 )
      IF (nEvent = xbeM_Motion .AND. mp1 == NIL) .OR. Valtype(oXbp)#'O'
         LOOP
      ENDIF
      oXbp:handleEvent( nEvent, mp1, mp2 )
      IF nEvent == xbeP_Keyboard
        EXIT
      ENDIF
    ENDDO
    oDialog:Destroy()
    IF lEmptyScreen
      saScreen := nil
    ELSE
      acSaveScreen := nil
    ENDIF
  ELSE
    IF !Empty(cColor)
      aColor := DC_Color2Gra(cColor)
      aPres := { {XBP_PP_FGCLR, aColor[1]}, {XBP_PP_BGCLR, aColor[2]} }
    ENDIF
    IF Valtype(oDialog:cargo) = 'A'
      aChildren := oDialog:cargo
      FOR i := 1 TO Len(aChildren)
        oXbp := aChildren[i]
        IF oXbp:ClassName() = 'XbpStatic' .AND. ;
           oXbp:currentPos()[1] = nCol .AND. ;
           oXbp:currentPos()[2] = nRow
          oXbp:SetCaption( cText )
          RETURN nil
        ENDIF
      NEXT
    ENDIF
    oXbp := XbpStatic():new( oDialog:drawingArea, , { nCol, nRow }, {300,15}, aPres )
    oXbp:setFontCompoundName( IIF(!Empty(cFont),cFont,cParentFont ) )
    oXbp:autoSize := .t.
    oXbp:caption := cText
    oXbp:clipsiblings := .t.
    oXbp:create()
    oXbp:show()
    AADD(oDialog:cargo,oXbp)
  ENDIF
ELSEIF Empty(acSaveScreen)
  cColor := IIF(Valtype(cColor)='C',cColor,SetColor())
  @ nRow, nCol SAY cText COLOR (cColor)
ELSE
  IF Valtype(acSaveScreen)='C'
    nStartrow := Val( Substr( acSaveScreen, 1, 3 ) )
    nStartcol := Val( substr( acSaveScreen, 4, 3 ) )
  ELSEIF Valtype(acSaveScreen)='A'
    nStartRow := acSaveScreen[1]
    nStartCol := acSaveScreen[2]
    lRelative := acSaveScreen[11]
  ENDIF
  lRelative := IIF(Valtype(lRelative)='L',lRelative,.t.)
  IF !lRelative
    nStartRow := 0
    nStartCol := 0
  ENDIF
  IF lOk
    DC_Ok( nStartRow + nRow - 1 , nStartCol + nCol, 1, .t. )
    DC_Impl(acSaveScreen)
  ELSE
    cColor := IIF(Valtype(cColor)='C',cColor,acSaveScreen[8])
    @ nStartRow + nRow, nStartCol + nCol + 1 SAY cText COLOR (cColor)
  ENDIF
ENDIF
RETURN nil

/*-----------------*/

FUNCTION dc_explmode ( lMode )
lINSTANTON := IIF(VALTYPE(lMode)='L',!lMode,lINSTANTON)
RETURN !lINSTANTON

/*-----------------*/

FUNCTION dc_altshadow ( nMode )
LOCAL nOldShadow := nSHADOW
DO CASE
  CASE VALTYPE(nMode)='L'
    nSHADOW := IIF(nMode,2,1)
  CASE VALTYPE(nMode)='N'
    nSHADOW := nMode
ENDCASE
RETURN nOldShadow

/*-----------------*/

FUNCTION dc_pushscrn ( aScrnStack, nSrow, nScol, nErow, nEcol, lExplode,;
                       cColor1, cColor2, lTone, cTitle, nSlideRate, lShadow,;
                       lPaintOnly, lDouble )

LOCAL cSaveScreen
lExplode := IIF(Valtype(lExplode)='L',lExplode,.f.)
cSaveScreen := DC_EXPLODE( nSrow, nScol, nErow, nEcol, cColor1, cColor2,;
                           lTone, cTitle, nSlideRate, lShadow, lPaintOnly, ;
                           lDouble, !lExplode )

IF VALTYPE( aScrnStack ) # 'A'
  aScrnStack := {}
ENDIF
AADD( aScrnStack, cSaveScreen )
RETURN aScrnStack

*-----------------

FUNCTION dc_popscrn ( aScrnStack )
LOCAL cSaveScreen
IF VALTYPE( aScrnStack ) = 'A' .AND. LEN(aScrnStack)>0
  cSaveScreen := aScrnStack[LEN(aScrnStack)]
  DC_IMPLODE( cSaveScreen, .t. )
  ASIZE( aScrnStack, LEN(aScrnStack)-1 )
ENDIF
RETURN aScrnStack

* ---------------

FUNCTION dc_waiton ( aMessage, lSound, cColor1, cColor2, nTop, nLeft, ;
                     cTitle, lWorking, oParent, oOwner, lModal, lAlways )

LOCAL nWidth, i, lPrint, oThread, cDevice, aSaveScrn, GetList[0], ;
      nCol, nRow, oDlg, drawingArea, oXbp, nHeight, GetOptions

lWorking := IIF( Valtype(lWorking)='L',lWorking,DC_WaitOnWorking() )
DEFAULT lModal := .f., ;
        lAlways := .t., ;
        cTitle := Chr(255) + DC_LangMsg(DCMSG_WORKING) + '...'

IF Valtype(aMessage) = 'B'
   aMessage := Eval(aMessage)
ENDIF
IF Valtype(aMessage)='U'
  aMessage := ' ' + DC_LangMsg(DCMSG_PLEASE_WAIT) + '... '
ENDIF
IF Valtype(aMessage)='C'
  aMessage := { aMessage }
ENDIF
nWidth := 0
FOR i := 1 TO LEN(aMessage)
  nWidth := Max(nWidth,LEN(aMessage[i]))
NEXT
IF DC_Gui() .OR. !(SetAppWindow():isDerivedFrom('XbpCrt'))
  IF Valtype(oParent) # 'O'
    oParent := AppDeskTop()
  ENDIF

  FOR i := 1 TO Len(aMessage) + IIF( lWorking, 1, 0 )
     @ i*20,0 DCSAY IIF(i <= Len(aMessage),aMessage[i],'') SIZE Max(nWidth*7,200) ;
       OBJECT oXbp FONT Dc_BaseFont()  // Jack Duijf 17-07-2014
//       OBJECT oXbp FONT '8.Helv'
  NEXT

  DCGETOPTIONS NOMINBUTTON NOMAXBUTTON NORESIZE ;
    _ALWAYSONTOP lAlways ;
    NOTASKLIST PIXEL HIDE

  DCREAD GUI FIT EXIT TITLE cTitle OPTIONS GetOptions APPWINDOW oParent ;
     EVAL {|o|oDlg := o} OWNER oOwner _MODAL lModal

  IF lWorking
     oThread := Thread():new()
     oDlg:cargo := {oXbp,.t.}
     Sleep(10)
     oThread:Start({||_Working(@oDlg,lAlways)})
  ENDIF
  DEFAULT oOwner := SetAppWindow()
  DC_CenterObject(oDlg,oOwner)
  oDlg:show()
  saWait := { , , , , , , , , , oDlg, SetAppWindow(), nil, .t., oThread, lModal }
  RETURN saWait

ELSE

  IF Valtype(nTop)#'N'
    nTop := (DC_MaxRow()/2) - (LEN(aMessage)/2) - 2
  ENDIF
  IF Valtype(nLeft)#'N'
    nLeft := (DC_MaxCol()/2) - (nWidth/2) - 2
  ENDIF
  cDevice := Set(_SET_DEVICE,'SCREEN')
  lPrint := Set(_SET_PRINTER,.f.)
  saWait := DC_Explode( nTop, nLeft, nTop+LEN(aMessage)+1, ;
                    nLeft+nWidth+1, cColor1, cColor2, lSound, cTitle )
  FOR i := 1 TO LEN(aMessage)
    @ nTop+i, nLeft+1 SAY aMessage[i]
  NEXT
  SET(_SET_PRINTER,lPrint)
  SET(_SET_DEVICE,cDevice)
ENDIF

RETURN saWait

* ------------

STATIC FUNCTION _Working( oDlg, lAlways )

LOCAL nCount := 1, oProgress := oDlg:cargo[1], nMaxCount := 24, ;
      nX, aSize, oPS, aAttr[ GRA_AA_COUNT], lOk := .t., mp1, mp2, ;
      oXbp, nEvent

oPS := oProgress:lockPS()
aSize := oProgress:currentSize()
aSize[1] -= 2
aSize[2] -= 2

SetAppFocus(oDlg)
// oDlg:setModalState(XBP_DISP_APPMODAL)

DO WHILE Valtype(oDlg) = 'O' .AND. oDlg:cargo[2] .AND. oDlg:status() > 0

  Sleep(20)
  DC_CompleteEvents()
  IF oDlg:status() > 0
    IF !(SetAppFocus()==oDlg) .AND. lAlways
      SetAppFocus(oDlg)
    ENDIF
    nX := aSize[1] * ( 1 / nMaxCount )
    nX := Min( nX, aSize[1] )           // Calculate width for rectangle
    IF nX <= 0
      nX := 1
    ENDIF
    nX := Int(nX)
    IF nCount = 1
      aAttr[ GRA_AA_COLOR ] := GRA_CLR_BACKGROUND
      GraSetAttrArea( oPS, aAttr )
      GraBox( oPS, {0,0}, {aSize[1]+2, aSize[2]+2}, GRA_FILL )
    ENDIF
    aAttr[ GRA_AA_COLOR ] := GRA_CLR_DARKBLUE
    GraSetAttrArea( oPS, aAttr )
    GraBox( oPS, { (nCount*nX) ,1}, { (nCount*nX) + nX - 3, aSize[2]}, GRA_FILL )
  ENDIF
  nCount++
  IF nCount > nMaxCount
    nCount := 1
  ENDIF

ENDDO

oProgress:unLockPS(oPS)

RETURN nil

/* --------------- */

FUNCTION dc_cls ( acSaveScreen )

LOCAL lEmptyScreen := .f., cSaveColor := SetColor(), i

IF Empty(acSaveScreen)
  acSaveScreen := saScreen
  lEmptyScreen := .t.
ENDIF
IF Valtype(acSaveScreen)='A' .AND. Valtype(acSaveScreen[10])='O'
  FOR i := 1 TO Len(acSaveScreen[10]:cargo)
    acSaveScreen[10]:cargo[i]:Destroy()
  NEXT
ELSEIF Valtype(acSaveScreen)='A'
  SetColor(acSaveScreen[8])
  @ acSaveScreen[1]+1, acSaveScreen[2]+3 CLEAR TO ;
    acSaveScreen[3]-2, acSaveScreen[4]-1
ELSE
  CLS
ENDIF
RETURN .t.

/* --------------- */

FUNCTION dc_maxrow()

IF SetAppWindow():ClassName() = 'XbpCrt'
  RETURN MaxRow()
ENDIF
RETURN 25

/* --------------- */

FUNCTION dc_maxcol()

IF SetAppWindow():ClassName() = 'XbpCrt'
  RETURN MaxCol()
ENDIF
RETURN 80

/* ---------------- */

FUNCTION dc_dispbox ( nT, nL, nB, nR, cBox, cColor )

IF !DC_Gui()
  RETURN DispBox ( nT, nL, nB, nR, cBox, cColor )
ENDIF
RETURN nil

/* ---------------- */

FUNCTION dc_scroll ( nT, nL, nB, nR )

IF !DC_Gui()
  RETURN Scroll( nT, nL, nB, nR )
ENDIF
RETURN nil

/* ---------------- */

FUNCTION DC_SetPos ( nT, nL )

IF !DC_Gui()
  RETURN SetPos( nT, nL )
ENDIF
RETURN nil

/* ---------------- */

FUNCTION DC_DevPos ( nT, nL )

IF !DC_Gui()
  RETURN DevPos( nT, nL )
ENDIF
RETURN nil

/* ---------------- */

FUNCTION DC_DevOut ( cSay, cColor )

IF !DC_Gui()
  RETURN DevOut( cSay, cColor )
ENDIF
RETURN nil

/* ----------------- */

FUNCTION DC_DevOutPict ( cText, cPict, cColor )

IF !DC_Gui()
  IF Empty(cPict)
    RETURN DevOut( cText, cColor )
  ENDIF
  RETURN DevOutPict( cText, cPict, cColor )
ENDIF
RETURN nil

/* ------------------ */

FUNCTION DC_WaitOnWorking( lWorking )

STATIC lWaitWorking := .t.
LOCAL lSaveWorking := lWaitWorking
IF Valtype(lWorking) = 'L'
   lWaitWorking := lWorking
ENDIF
RETURN lSaveWorking

* -----------------

FUNCTION DC_WaitOnObject()

RETURN saWait

* --------------

FUNCTION DC_MessageParent( oMsgBox )

STATIC soMsgBox
LOCAL oOldMsgBox := soMsgBox
IF PCount() > 0
  soMsgBox := oMsgBox
ENDIF
RETURN oOldMsgBox

* --------------

FUNCTION DC_MessageOptions( aOptions )

/*
aOptions[1] - mode
aOptions[2] - blink rate
aOptions[3] - time out
aOptions[4] - clear message window on close
*/

STATIC saOptions := { 0, 0, 0, .t. }
LOCAL aOldOptions := saOptions

IF Pcount() > 0
  saOptions := aOptions
ENDIF

RETURN aOldOptions

* --------------

FUNCTION DC_MessageOn ( cMessage, oParent, nBlink, nColor, cFont, nMode, nTimeOut )

LOCAL oThread, cID := Alltrim(Str(Seconds())), aMessage, aCargo, ;
      nSaveColorFG, cSaveFont

LOCAL aOptions := DC_MessageOptions()
DEFAULT aOptions := {0,0,0,.f.}

DEFAULT nMode := aOptions[1], ;
        nBlink := aOptions[2], ;
        nTimeOut := aOptions[3], ;
        oParent := DC_MessageParent()

IF Valtype(oParent) # 'O'
  RETURN nil
ENDIF

nSaveColorFG := oParent:setColorFG()
cSaveFont := oParent:setFontCompoundName()

IF Valtype(cMessage)='U'
  cMessage := ' Please wait... '
ENDIF                                                                              r

aCargo := {.t., 0, nBlink, nMode, {}}
IF Empty(oParent:cargo)
  oParent:cargo := { nil, nil, nil, .f. }
ENDIF
IF Empty(oParent:cargo[3])
  oParent:cargo[3] := aCargo
ENDIF
aMessage := { cMessage, cID, nTimeOut, nColor, cFont }
AAdd(oParent:cargo[3,5],aMessage)
oParent:cargo[3,2] := Len(oParent:cargo[3,5])

IF Len(oParent:cargo[3,5]) == 1
  oThread := Thread():new()
  Sleep(10)
  oThread:Start({||_MsgWorking(oParent,nBlink,nTimeOut)})
ENDIF

RETURN { oParent, cID, nSaveColorFG, cSaveFont }

* ------------

FUNCTION DC_MessageOff( aMessage, lClear )

LOCAL oParent, cID, aCargo, nFound, nColorFG, cFont, aOptions

IF Valtype(aMessage) # 'A'
  RETURN .f.
ENDIF

oParent := aMessage[1]
cID := aMessage[2]

aCargo := oParent:cargo[3,5]
nFound := aScan(aCargo,{|a|a[2] == cID})
nColorFG := aMessage[3]
cFont := aMessage[4]
aOptions := DC_MessageOptions()

DEFAULT aOptions := {0,0,0,.f.}
DEFAULT lClear := aOptions[4]

IF nFound > 0
  ARemove( aCargo, nFound )
  Sleep(50)
  oParent:setColorFG(nColorFG)
  oParent:setFontCompoundName(cFont)
  IF lClear
    oParent:setCaption('')
  ENDIF
  RETURN .t.
ENDIF

RETURN .f.

* ------------

STATIC FUNCTION _MsgWorking( oParent, nSleep, nTimeOut )

LOCAL nMessagePointer, cCaption, nColorFG, cFont, nTimer := Seconds(), ;
      nDots := 0

DO WHILE Valtype(oParent) = 'O' .AND. !Empty(oParent:cargo[3,5]) ;
   .AND. IIF( nTimeOut > 0, Seconds() - nTimer < nTimeOut, .t. )

  nMessagePointer := oParent:cargo[3,2]
  IF nMessagePointer == 0 .AND. nSleep == 0
    nMessagePointer := 1
  ENDIF

  IF nMessagePointer > 0 .AND. Len(oParent:cargo[3,5]) >= nMessagePointer
    cCaption := oParent:cargo[3,5,nMessagePointer,1] // + Repl('.',nDots)
    IF Valtype(cCaption) == 'B'
      cCaption := Eval(cCaption)
    ENDIF
    nColorFG := oParent:cargo[3,5,nMessagePointer,4]
    cFont := oParent:cargo[3,5,nMessagePointer,5]
    IF Valtype(cCaption) == 'C' .AND. !(cCaption == oParent:caption)
      oParent:setCaption( cCaption )
    ENDIF
    IF Valtype(nColorFG) == 'N' .AND. !(nColorFG == oParent:setColorFG())
      oParent:setColorFG(nColorFG)
    ENDIF
    IF Valtype(cFont)=='C' .AND. !(cFont == oParent:setFontCompoundName())
      oParent:setFontCompoundName(cFont)
    ENDIF
  ELSE
    oParent:setCaption('')
  ENDIF
  nMessagePointer++

  IF nMessagePointer > Len(oParent:cargo[3,5])
    IF Len(oParent:cargo[3,5]) > 1
      nMessagePointer := 1
    ELSE
      nMessagePointer := 0
    ENDIF
  ENDIF
  oParent:cargo[3,2] := nMessagePointer

  IF nSleep == 0
    Sleep(10)
  ELSE
    Sleep(nSleep)
  ENDIF
  nDots ++
  IF nDots > 20
    nDots := 0
  ENDIF

ENDDO

RETURN nil

